

Vagrant.configure("2") do |config|


  # tool config (dns, dhcp, etc.)
  (1..{{ tool_number }}).each do |i|
    config.vm.define "{{ tool_hostname_begin }}#{i}{{ tool_hostname_ending }}" do |tool|
      tool.vm.box      =        "{{ tool_image_name }}"
      tool.vm.box_url  =        "{{ tool_image_name }}"
      tool.vm.hostname =        "{{ tool_hostname_begin }}#{i}{{ tool_hostname_ending }}.{{ domain_name }}"
      tool.vm.network "private_network", ip: "{{ vagrant_node_network_base }}.#{i+1}"
      
      tool.vm.provider "{{ tool_vm_provider }}" do |vtool|
        vtool.memory = "{{ tool_memory }}"
        vtool.cpus   = "{{ tool_cpus   }}"
        vtool.keymap = "{{ tool_keymap }}"
      end

      ssh_pub_key = File.readlines("#{Dir.home}/.ssh/id_ed25519.pub").first.strip
      config.vm.provision 'shell', inline: 'mkdir -p /root/.ssh'
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /root/.ssh/authorized_keys"
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /home/{{ k8s_user }}/.ssh/authorized_keys", privileged: false

    end
  end


  # master node config
  (1..{{ master_number }}).each do |i|
    config.vm.define "{{ master_hostname_begin }}#{i + {{ tool_number }}}{{ master_hostname_ending }}" do |master|
      master.vm.box      =        "{{ master_image_name }}"
      master.vm.box_url  =        "{{ master_image_name }}"
      master.vm.hostname =        "{{ master_hostname_begin }}#{i + {{ tool_number }}}{{ master_hostname_ending }}.{{ domain_name }}" 
      master.vm.network "private_network", ip: "{{ vagrant_node_network_base }}.#{i + {{ tool_number }} + 1}"
      
      master.vm.provider "{{ master_vm_provider }}" do |vmaster|
        vmaster.memory = "{{ master_memory }}"
        vmaster.cpus   = "{{ master_cpus   }}"
        vmaster.keymap = "{{ master_keymap }}"
      end

      ssh_pub_key = File.readlines("#{Dir.home}/.ssh/id_ed25519.pub").first.strip
      config.vm.provision 'shell', inline: 'mkdir -p /root/.ssh'
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /root/.ssh/authorized_keys"
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /home/{{ k8s_user }}/.ssh/authorized_keys", privileged: false

    end
  end


  # worker node config
  (1..{{ worker_number }}).each do |i|
    config.vm.define "{{ worker_hostname_begin }}#{i + {{ tool_number }} + {{ master_number }}}{{ worker_hostname_ending }}" do |worker|
      worker.vm.box =             "{{ worker_image_name }}"
      worker.vm.box_url =         "{{ worker_image_name }}"
      worker.vm.hostname =        "{{ worker_hostname_begin }}#{i + {{ tool_number }} + {{ master_number }}}{{ worker_hostname_ending }}.{{ domain_name }}"
      worker.vm.network "private_network", ip: "{{ vagrant_node_network_base }}.#{i + {{ tool_number }} + {{ master_number }} + 1}"
      
      worker.vm.provider "{{ worker_vm_provider }}" do |vworker|
        vworker.memory = "{{ worker_memory }}"
        vworker.cpus   = "{{ worker_cpus   }}"
        vworker.keymap = "{{ worker_keymap }}"
      end

      ssh_pub_key = File.readlines("#{Dir.home}/.ssh/id_ed25519.pub").first.strip
      config.vm.provision 'shell', inline: 'mkdir -p /root/.ssh'
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /root/.ssh/authorized_keys"
      config.vm.provision 'shell', inline: "echo #{ssh_pub_key} >> /home/{{ k8s_user }}/.ssh/authorized_keys", privileged: false

    end


  end

end
